//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
float2 R : SIZEOF <string ref="tex0";> ;

float4x4 tW : WORLD;

SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_POINT;AddressU=CLAMP;AddressV=CLAMP;};

struct Particle
{
	float2 uv;
	float4 col;
};

AppendStructuredBuffer<Particle> Output : BACKBUFFER;

float thrs;

[numthreads(8, 8, 1)]
void CS( uint3 tid : SV_DispatchThreadID )
{
	float2 uv = 1/R * tid.xy;
	
	float4 col = tex0.SampleLevel(s0,uv,0);
	
	float avg = (col.r + col.g + col.b)/3;
	
	if (avg > thrs)
	{
		
		uv = float2 (uv.x, 1 - uv.y) - 0.5;
		uv = mul (float4 (uv,0,1), tW).xy;
		
		Particle particle;
		particle.uv = uv;
		particle.col = col;
		Output.Append(particle);
	}
	
}


technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




